SystemOrganization addCategory: #ConfigurationOfPierAdmin!

Object subclass: #ConfigurationOfPierAdmin
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPierAdmin'!

!ConfigurationOfPierAdmin class methodsFor: 'development support' stamp: 'NickAger 10/13/2011 15:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPierAdmin class methodsFor: 'private' stamp: 'NickAger 10/13/2011 15:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPierAdmin class methodsFor: 'private' stamp: 'NickAger 10/13/2011 15:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPierAdmin class methodsFor: 'private' stamp: 'NickAger 10/13/2011 15:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPierAdmin class methodsFor: 'metacello tool support' stamp: 'NickAger 10/13/2011 15:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPierAdmin class methodsFor: 'loading' stamp: 'NickAger 10/13/2011 15:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPierAdmin class methodsFor: 'loading' stamp: 'NickAger 10/13/2011 15:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPierAdmin class methodsFor: 'loading' stamp: 'NickAger 10/13/2011 15:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPierAdmin class methodsFor: 'accessing' stamp: 'NickAger 10/13/2011 15:05'!
project

	^self new project! !

!ConfigurationOfPierAdmin class methodsFor: 'development support' stamp: 'NickAger 10/13/2011 15:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPierAdmin methodsFor: 'baselines' stamp: 'NickAger 11/25/2011 16:21'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://source.lukas-renggli.ch/pier2addons'.
		
		spec project: 'Seaside30' with: [
   			spec
     				className: 'ConfigurationOfSeaside30';
     				versionString: #stable;
     				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
			
		spec project: 'PierAddOns' with: [
   			spec
     				className: 'ConfigurationOfPierAddOns2';
     				versionString: '2.1.0';
				loads: #('Pier-Blog' 'Pier-Book' 'Pier-Design' 'Pier-Documents' 'Pier-EditorEnh' 'Pier-Google' 'Pier-JQuery' 'Pier-LinkChecker' 'Pier-TagCloud' 'Pier-Wysiwyg' 'Pier-Tests-Wysiwyg' 'Pier-FileUpload-Common-Wysiwyg' 'Pier-FileUpload-Wysiwyg' 'Pier-Shout');
     				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
			
		spec project: 'JQuery Widgetbox' with: [
				spec
					className: 'ConfigurationOfJQueryWidgetBox';
					versionString: '1.5';
					loads: #('JQWidgetBox-UILayout-Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
				
		spec 
			package: 'JQWidgetBox-JSTree-Core';
			package: 'Pier-Kernel-Distributions';
			package: 'Pier-Admin' with: [
				spec requires: #('Seaside30' 'PierAddOns' 'JQuery Widgetbox' 'Pier-Kernel-Distributions' 'JQWidgetBox-JSTree-Core') ] ]! !

!ConfigurationOfPierAdmin methodsFor: 'accessing' stamp: 'NickAger 10/13/2011 15:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
